package xxx.oracle.apps.inv.rcv.server;

import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;

import oracle.apps.inv.lov.server.*;
import oracle.apps.inv.rcv.server.DescField;
import oracle.apps.inv.rcv.server.RcptGenFListener;
import oracle.apps.inv.rcv.server.RcptGenPage;
import oracle.apps.inv.rcv.server.RcvPage;
import oracle.apps.inv.utilities.server.DualUOMFields;
import oracle.apps.inv.utilities.server.NumberFieldBean;
import oracle.apps.inv.utilities.server.UtilFns;
import oracle.apps.mwa.beans.ButtonFieldBean;
import oracle.apps.mwa.beans.FieldBean;
import oracle.apps.mwa.beans.TextFieldBean;
import oracle.apps.mwa.container.MWALib;
import oracle.apps.mwa.container.Session;
import oracle.apps.mwa.eventmodel.*;
import java.sql.CallableStatement;
import java.sql.Connection;

import java.sql.Types;

import oracle.apps.mwa.container.Logger;

// Referenced classes of package xxx.oracle.apps.inv.rcv.server:
//            xxxRcptGenPage

public class xxxRcptGenFListener extends RcptGenFListener
{

    private ProjectLOV prjBean;
    private TaskLOV taskBean;
    public String invItemID;
    private String documentType;
    private POLOV poBean;
    private POLineNumLOV poLineBean;
    private RMALOV rmaBean;
    private RequisitionNumLOV reqBean;
    private String poHeaderId;
    private String poLineId;
    private String oeHeaderId;
    private String reqHeaderId;
    private String shipmentHeaderId;
    private LPNLOV lpnBean;
    private String mOrigProjectValue;
    private String mOrigTaskValue;
    private String mOrigLocationValue;
    private String mOrigItemWeightValue;
    private String mOrigLPNValue;

    public xxxRcptGenFListener()
    {
    }

    public void fieldEntered(MWAEvent mwaevent)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        UtilFns.trace("xxxRcptGenFListener.fieldEntered Entered");
        super.fieldEntered(mwaevent);
        Session session = mwaevent.getSession();
        String s = UtilFns.fieldEnterSource(session);
        /*if(s.equals("XX.IWEIGHT"))
        {
            UtilFns.trace("xxxRcptGenFListener.fieldEntered Entered: mItemWeightField");
            itemWeightEntered(mwaevent);
        }*/
        if(s.equals("INV.DOC_NUMBER"))
            docEntered(mwaevent);
        else
        if(s.equals("INV.PO_LINE_NUMBER"))
            poLineNumEntered(mwaevent);
        else
        if(s.equals("INV.ITEM"))
            itemEntered(mwaevent);
        else
        if(s.equals("INV.SUB"))
            subEntered(mwaevent);
        else
        if(s.equals("RCV.PROJECT"))
            prjEntered(mwaevent);
        else
        if(s.equals("RCV.TASK"))
            taskEntered(mwaevent);
        else
        if(s.equals("INV.LPN"))
            lpnEntered(mwaevent);
        else
        if(s.equals("INV.REV"))
            revEntered(mwaevent);
        else
        if(s.equals("RCV.ATTACHMENT"))
            attachmentBtnEntered(mwaevent);
        else
        if(s.equals("INV.UOM"))
            receivedUOMEntered(mwaevent);
        else
        if(s.equals("INV.LOT"))
            LotEntered(mwaevent);
        else
        if(s.equals("INV.SERIAL") || s.equals("INV.FROM_SERIAL"))
            serialEntered(mwaevent);
        else
        if(s.equals("INV.LOC"))            
            locEntered(mwaevent);
        else
        if(s.equals("INV.JOB"))
            jobEntered(mwaevent);
        else
        if(s.equals("INV.FROM_LPN"))
            fromlpnEntered(mwaevent);
        else
        if(s.equals("INV.COUNTRY_CODE"))
            countryEntered(mwaevent);
        else
        if(s.equals("INV.LOCATION"))
        {
            UtilFns.trace("xxxRcptGenFListener.fieldEntered START s.equals(INV.LOC)");
            locationEntered(mwaevent);
            UtilFns.trace("xxxRcptGenFListener.fieldEntered START s.equals(INV.LOC)");
        }
        else
        if(s.equals("INV.PO_RELEASE_NUMBER"))
            poReleaseNumEntered(mwaevent);
        else
        if(s.equals("INV.LOT_QTY"))
            lotQtyEntered(mwaevent);
        else
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.fieldEntered - complete");
    }

    public void itemWeightEntered(MWAEvent mwaevent) throws AbortHandlerException, 
                                                        InterruptedHandlerException, 
                                                        DefaultOnlyHandlerException
    {        
        UtilFns.trace("xxxRcptGenFListener: itemWeightEntered Entered");
    }    
    
    private void docEntered(MWAEvent mwaevent)
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.docEntered 10");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        DOCLOV doclov = rcptgenpage.getDocFld();
        ItemLOV itemlov = rcptgenpage.getItemFld();
        Hashtable hashtable = (Hashtable)session.getObject("receiving.po_startup_values_block");
        String s = (String)hashtable.get("manual_po_num_type");
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.docEntered 20 - manualPONumType = " + s);
        String s1 = itemlov.getValue();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.docEntered = " + s1);
        String s2 = itemlov.getItemID();
        if(s2.equalsIgnoreCase("NULL"))
            s2 = "";
        String s3 = "";
        if(s2 == null || s2.equals("") || s2.equalsIgnoreCase("NULL"))
        {
            s2 = "";
            s3 = rcptgenpage.getItemFld().getDesc();
            UtilFns.trace("RCV: xxxRcptGenFListener.docEntered s3 = " + s3);
        }
        String s4 = "";
        if(itemlov.getIsVendorItem().equals("Y"))
            s4 = rcptgenpage.getVendorItemFld().getValue();
        UtilFns.trace("RCV: xxxRcptGenFListener.docEntered s4 = " + s4);
        String s5 = (String)session.getObject("TXN.DOCTYPE");
        UtilFns.trace("RCV: xxxRcptGenFListener.docEntered s5 = " + s5);
        if(s5 == null)
            s5 = "ALL";
        try
        {
            if(s5.equals("PO"))
            {
                doclov.setPrompt(MWALib.getAKPrompt(session, "oracle.apps.inv.utilities.InvResourceTable", "INV_PURCHASE_ORDER_NUM_PROMPT"));
                doclov.retrieveAttributes("INV_PURCHASE_ORDER_NUM_PROMPT");
            } else
            if(s5.equals("RMA"))
            {              
                doclov.setPrompt(MWALib.getAKPrompt(session, "oracle.apps.inv.utilities.InvResourceTable", "INV_RMA_AUTHORIZATION_PROMPT"));
                doclov.retrieveAttributes("INV_RMA_AUTHORIZATION_PROMPT");
            } else
            if(s5.equals("ASN"))
            {
                doclov.setPrompt(MWALib.getAKPrompt(session, "oracle.apps.inv.utilities.InvResourceTable", "INV_ASN_NUMBER_PROMPT"));
                doclov.retrieveAttributes("INV_ASN_NUMBER_PROMPT");
            } else
            if(s5.equals("REQ"))
            {
                doclov.setPrompt(MWALib.getAKPrompt(session, "oracle.apps.inv.utilities.InvResourceTable", "INV_REQUISITION_NUMBER_PROMPT"));
                doclov.retrieveAttributes("INV_REQUISITION_NUMBER_PROMPT");
            } else
            if(s5.equals("INTSHIP"))
            {
                doclov.setPrompt(MWALib.getAKPrompt(session, "oracle.apps.inv.utilities.InvResourceTable", "INV_SHIPMENT_NUMBER_PROMPT"));
                doclov.retrieveAttributes("INV_SHIPMENT_NUMBER_PROMPT");
            } else
            {
                doclov.setPrompt(MWALib.getAKPrompt(session, "oracle.apps.inv.utilities.InvResourceTable", "INV_DOC_NUM_PROMPT"));
                doclov.retrieveAttributes("INV_DOC_NUM_PROMPT");
            }
        }
        catch(SQLException sqlexception)
        {
            UtilFns.error("RCV: xxxRcptGenFListener Error in Setting Prompts", sqlexception);
            session.setStatusMessage(UtilFns.getMessage(session, "INV", "INV_MWA_DB_ERROR"));
        }
        if(s2 != null && !s2.equals(""))
        {
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener.docEntered 30 itemId = " + s2);
            String as[] = {
                " ", "ORGID", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.DOC_NUMBER", "RECEIPT", s, "", s2, "", s4
            };
            doclov.setInputParameters(as);
        } else
        {
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener.docEntered 40 itemId = " + s2 + "ItemDesc =" + s3);
            String as1[] = {
            " ", "ORGID", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.DOC_NUMBER", "RECEIPT", s, "", "", s5, s4
            };
            doclov.setInputParameters(as1);
        }
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.docEntered - complete");
    }

    private void poLineNumEntered(MWAEvent mwaevent)
        throws AbortHandlerException
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.poLineNumEntered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        rcptgenpage.getPOLineNumFld();
        DOCLOV doclov = rcptgenpage.getDocFld();
        String s = rcptgenpage.getItemFld().getItemID();
        String as[] = {
        " ", "ORGID", doclov.getPOHeaderID(), "RECEIPT", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.PO_LINE_NUMBER",""
        };
        rcptgenpage.getPOLineNumFld().setInputParameters(as);
    }

    private void itemEntered(MWAEvent mwaevent)
        throws AbortHandlerException
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.itemEntered");
        Session session = mwaevent.getSession();
        initBean(session);
        String s = "";
        s = (String)session.getObject("TXN.ITEM_CONTROLLED");
        if(s == null)
            s = "";
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        DOCLOV doclov = rcptgenpage.getDocFld();
        String s1 = (String)session.getObject("CROSS_REF_TYPE");
        ItemLOV itemlov = rcptgenpage.getItemFld();
        itemlov.setNextPageName(null);
        itemlov.setValidateFromLOV(true);
        String s2 = doclov.getDocType();
        if((s2.equalsIgnoreCase("PO") || s2.equalsIgnoreCase("RMA")) && UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.Doctype - is " + s2);
        String s3 = rcptgenpage.getDocFld().getPOHeaderID();
        String s4 = rcptgenpage.getPOReleaseNumFld().getPOReleaseID();
        String s5 = rcptgenpage.getPOLineNumFld().getPOLineID();
        String s6 = rcptgenpage.getShipmentNumFld().getShipmentHeaderID();
        String s7 = rcptgenpage.getRMAFld().getOrderHeaderID();
        String s8 = rcptgenpage.getReqNumFld().getReqHeaderID();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener Before Setting Proj fields");
        String s9 = prjBean.getProjectId();
        String s10 = taskBean.getTaskId();
        String s11 = "2";
        if(UtilFns.isPJMOrg(session))
            s11 = "1";
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener Before Setting Item Input ");
        LPNLOV lpnlov = rcptgenpage.getFromLPNFld();
        String s12 = "";
        String s13 = (new Long(lpnlov.getLPNId())).toString();
        if(s13 == null || s13.equals("0") || s13.equals("-1"))
            s13 = "";
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: Patchset J code xxxRcptGenFListener fromlpnID= " + s13);
        String as[] = {
            " ", "ORGID", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.ITEM", s3, s4, s5, s6, s7, s8, s9, 
            s10, s11, s1, s13
        };
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.itemEntered 90 - ");
        itemlov.setLOVType("INV_ASSET");
        itemlov.setlovStatement("INV_UI_RCV_LOVS.GET_ITEM_LOV_RECEIVING");
        String as2[] = {
            "C", "N", "S", "AS", "AS", "AS", "AS", "AS", "AS", "AS", 
            "AS", "AS", "AS", "AS"
        };
        itemlov.setInputParameterTypes(as2);
        itemlov.setInputParameters(as);
        UtilFns.log("after setting inputs");
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.itemEntered 110 ");
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.itemEntered - complete");
    }

    private void subEntered(MWAEvent mwaevent)
    {
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        ItemLOV itemlov = rcptgenpage.getItemFld();
        UtilFns.log("Getting sublov bean");
        SubinventoryLOV subinventorylov = rcptgenpage.getSubFld();
        String s = (String)session.getObject("receiving.RoutingID");
        String s1 = "";
        String s2 = "FALSE";
        if(rcptgenpage.getLocationFld() != null && !rcptgenpage.getLocationFld().getValue().equals("") && s != null && !s.equals("3"))
            s1 = rcptgenpage.getLocationFld().getLocationID();
        if(session.getObject("wms_purchased") != null && ((String)session.getObject("wms_purchased")).equals("I"))
            s2 = "TRUE";
        String as[] = {
            " ", "ORGID", itemlov.getItemID(), "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.SUB", itemlov.getRestrictSubCode(), "transaction_type", s2, s1
        };
        subinventorylov.setInputParameters(as);
        String as2[] = {
            "C", "N", "AN", "S", "AN", "N", "AS", "AS"
        };
        subinventorylov.setInputParameterTypes(as2);
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.subEntered. - complete");
    }

    private void prjEntered(MWAEvent mwaevent)
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("Entered project entered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        String s = rcptgenpage.getItemFld().getItemID();
        String s1;
        if(rcptgenpage.getFromLPNFld().getLPNId() <= 0L)
            s1 = "";
        else
            s1 = (new Long(rcptgenpage.getFromLPNFld().getLPNId())).toString();
        DOCLOV doclov = rcptgenpage.getDocFld();
        documentType = doclov.getDocType();
        String s2 = rcptgenpage.getPOReleaseNumFld().getPOReleaseID();
        if(UtilFns.isTraceOn)
            UtilFns.trace("parameters for doc " + documentType);
        if(UtilFns.isTraceOn)
            UtilFns.trace("po header: " + poHeaderId + " poline: " + poLineId + " item: " + s + " reqheaderid: " + reqHeaderId + " shipmentid " + shipmentHeaderId + " oeheaderid: " + oeHeaderId + " lpnid: " + s1 + " poReleaseID: " + s2);
        mOrigProjectValue = prjBean.getValue();
        String as[] = {
            " ", documentType, poHeaderId, poLineId, oeHeaderId, reqHeaderId, shipmentHeaderId, "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.RCV.PROJECT", s, s1, 
            s2
        };
        prjBean.setInputParameters(as);
        session.setRefreshScreen(true);
    }

    private void taskEntered(MWAEvent mwaevent)
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("Entered task entered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        String s = rcptgenpage.getItemFld().getItemID();
        String s1;
        if(rcptgenpage.getFromLPNFld().getLPNId() <= 0L)
            s1 = "";
        else
            s1 = (new Long(rcptgenpage.getFromLPNFld().getLPNId())).toString();
        String s2 = rcptgenpage.getPOReleaseNumFld().getPOReleaseID();
        DOCLOV doclov = rcptgenpage.getDocFld();
        documentType = doclov.getDocType();
        if(UtilFns.isTraceOn)
            UtilFns.trace("Doctype:" + documentType + " po header: " + poHeaderId + " poline: " + poLineId + " item: " + s + " reqheaderid: " + reqHeaderId + " shipmentid " + shipmentHeaderId + " oeheaderid: " + oeHeaderId + "poReleaseID" + s2);
        mOrigTaskValue = taskBean.getValue();
        String as[] = {
            "C", "AS", "AS", "AS", "AS", "AS", "AS", "AS", "S", "AS", 
            "AS", "AS"
        };
        taskBean.setInputParameterTypes(as);
        String as2[] = {
            " ", documentType, poHeaderId, poLineId, oeHeaderId, reqHeaderId, shipmentHeaderId, prjBean.getProjectId(), "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.RCV.TASK", s, 
            s1, s2
        };
        taskBean.setInputParameters(as2);
        session.setRefreshScreen(true);
    }

    private void lpnEntered(MWAEvent mwaevent)
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.lpnEntered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        LPNLOV lpnlov = rcptgenpage.getLPNFld();
        String s = (String)session.getObject("RCV.ASN_LPN_ID");
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.lpnEntered - fromLPNID = " + s);
        String s1 = prjBean.getProjectId();
        String s2 = taskBean.getTaskId();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.lpnEntered- projectId = " + s1 + " taskid = " + s2);
        if(s == null)
            s = "";
        String as[] = {
            " ", "ORGID", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.LPN", s, s1, s2
        };
        lpnlov.setInputParameters(as);
        String s3 = (String)session.getObject("menu.TransactionSourceType");
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.lpnEntered - txnSourceType = " + s3);
        if(s3.equals("ASNCONFM"))
            lpnlov.clear();
        mOrigLPNValue = lpnlov.getValue();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.lpnEntered - complete");
    }

    private void revEntered(MWAEvent mwaevent)
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.revEntered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        ItemLOV itemlov = rcptgenpage.getItemFld();
        String s = itemlov.getRevCode();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.revEntered - revCode = " + s);
        if(s.equals("2"))
        {
            RevisionLOV revisionlov = rcptgenpage.getRevFld();
            String as[] = {
                " ", "ORGID", itemlov.getItemID(), "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.REV"
            };
            revisionlov.setInputParameters(as);
        }
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.revEntered - complete");
    }

    private void attachmentBtnEntered(MWAEvent mwaevent)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        Session session = mwaevent.getSession();
        xxxRcptGenPage _tmp = (xxxRcptGenPage)session.getCurrentPage();
        String s = ((FieldBean)mwaevent.getSource()).getName();
        if(mwaevent.getAction().equals("MWA_ACCELERATOR"))
        {
            session.putObject("FROM_HOT_KEY", "Y");
            session.putObject("ATTACH_BTN_PREV_FIELD", s);
        } else
        {
            session.putObject("FROM_HOT_KEY", "N");
        }
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.AttachmentBtnEntered" + s);
    }

    private void receivedUOMEntered(MWAEvent mwaevent)
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.receivedUOMEntered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        ItemLOV itemlov = rcptgenpage.getItemFld();
        UomLOV uomlov = rcptgenpage.getUOMFld();
        String s = itemlov.getAllowedUnitsLookupCode();
        String s1 = itemlov.getItemID();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.receivedUOMEntered - itemID" + s1);
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.receivedUOMEntered - allowedUnitsLookupCode" + s);
        if(s1 != null && !s1.equals("") && !s1.equals("NULL"))
        {
            uomlov.setlovStatement("INV_UI_ITEM_LOVS.GET_UOM_LOV_RCV");
            String as[] = {
                " ", "ORGID", s1, s, "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.UOM"
            };
            uomlov.setInputParameters(as);
        } else
        {
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener - itemID null");
            String s2 = "-1";
            String s3 = rcptgenpage.getItemFld().getPrimaryUOM();
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener - primary uom code from po lines " + s3);
            uomlov.setlovStatement("INV_UI_RCV_LOVS.GET_UOM_LOV_EXPENSE");
            String as1[] = {
                "C", "N", "AN", "AN", "S", "AS"
            };
            uomlov.setInputParameterTypes(as1);
            String as2[] = {
                " ", "ORGID", s2, s, "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.UOM", s3
            };
            uomlov.setInputParameters(as2);
        }
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.receivedUOMEntered - complete");
    }

    private void lotQtyEntered(MWAEvent mwaevent)
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener 10 lotQtyEntered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        String s = rcptgenpage.getRemainingQtyFld().getNumberValue();
        LotLOV lotlov = new LotLOV();
        lotlov.copyLotLOV(rcptgenpage.getLotFld());
        session.putObject("LOT_LOV", lotlov);
        session.putObject("REMAINING_QTY", s);
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener 20 lotQtyEntered");
    }

    private void LotEntered(MWAEvent mwaevent)
        throws AbortHandlerException
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        LotLOV lotlov = rcptgenpage.getLotFld();
        ItemLOV itemlov = rcptgenpage.getItemFld();
        boolean flag = false;
        String s = (String)session.getObject("menu.TransactionSourceType");
        String s1 = "FALSE";
        if(session.getObject("wms_purchased") != null && ((String)session.getObject("wms_purchased")).equals("I"))
            s1 = "TRUE";
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered - wmsInstalled = " + s1);
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered - txnSourceType = " + s);
        session.putObject("EnableLotGen", "TRUE");
        if(s.equals("7"))
        {
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered 50");
            String s2 = rcptgenpage.getShipmentNumFld().getShipmentHeaderID();
            String s4 = "";
            if(session.getObject("menu.TransactionName") != null)
                s4 = (String)session.getObject("menu.TransactionName");
            if(s4.equalsIgnoreCase("REQ") || s4.equalsIgnoreCase("REQEXP") || s4.equalsIgnoreCase("REQCONFM"))
            {
                s2 = (String)session.getObject("REQ_SHIPMENT_HEADER_ID");
                if(s2 == null || s2.equalsIgnoreCase("NULL") || s2.equals(""))
                    s2 = getShipmentHeaderId(mwaevent);
            }
            String as3[] = {
                " ", "ORGID", rcptgenpage.getItemFld().getItemID(), s2, "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.LOT", "transaction_type", s1
            };
            rcptgenpage.getLotFld().setInputParameters(as3);
            rcptgenpage.getLotFld().setlovStatement("INV_INV_LOVS.GET_LOT_LOV_INT_SHP_RCV");
            String as5[] = {
                "C", "N", "AN", "AN", "S", "S", "AS"
            };
            rcptgenpage.getLotFld().setInputParameterTypes(as5);
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered - Calling get_lot_control_from_org");
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered - shipmenthedareid" + s2);
            try
            {
                String as6[] = {
                    "x_lot_control_code", "x_from_org_id", "p_organization_id", "p_shipment_header_id", "p_item_id"
                };
                String as7[] = {
                    "O", "O", "I", "I", "I"
                };
                String as8[] = {
                    "N", "N", "N", "N", "N"
                };
                String as9[] = {
                    (String)session.getObject("ORGID"), s2, rcptgenpage.getItemFld().getItemID()
                };
                if(UtilFns.isTraceOn)
                    UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered - After setiing params");
                java.sql.Connection connection = session.getConnection();
                Hashtable hashtable = UtilFns.ProcessAPI(connection, "INV_INV_LOVS.get_lot_control_from_org", as6, as7, as8, as9);
                if(UtilFns.isTraceOn)
                    UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered - After calling ");
                String s5 = "2";
                if((String)hashtable.get("x_lot_control_code") != null)
                    s5 = (String)hashtable.get("x_lot_control_code");
                if(UtilFns.isTraceOn)
                    UtilFns.trace("Lot control at source org: " + s5);
                if((String)hashtable.get("x_from_org_id") != null)
                    session.putObject("LOT_ATT.FROM_ORG_ID", (String)hashtable.get("x_from_org_id"));
                if(s5.equals("2"))
                {
                    flag = true;
                    session.putObject("EnableLotGen", "FALSE");
                } else
                {
                    flag = false;
                }
            }
            catch(SQLException _ex)
            {
                flag = true;
            }
        } else
        if(s.equals("ASNCONFM"))
        {
            String s3 = rcptgenpage.getShipmentNumFld().getShipmentHeaderID();
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered - shipmentheaderid = " + s3);
            String as1[] = {
                " ", "ORGID", rcptgenpage.getItemFld().getItemID(), "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.LOT", "transaction_type", s1, "", "", "", s3
            };
            rcptgenpage.getLotFld().setInputParameters(as1);
            rcptgenpage.getLotFld().setlovStatement("INV_INV_LOVS.ASN_LOT_LOV");
            String as4[] = {
                "C", "N", "AN", "S", "N", "AS", "N", "S", "N", "AN"
            };
            rcptgenpage.getLotFld().setInputParameterTypes(as4);
        } else
        {
            String as[] = {
                " ", "ORGID", itemlov.getItemID(), "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.LOT", "transaction_type", s1
            };
            lotlov.setInputParameters(as);
            String as2[] = {
                "C", "N", "AN", "S", "N", "AS"
            };
            lotlov.setInputParameterTypes(as2);
        }
        rcptgenpage.getLotFld().setValidateFromLOV(flag);
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.lotEntered - complete");
    }

    private String getShipmentHeaderId(MWAEvent mwaevent)
        throws AbortHandlerException
    {
        Object obj = null;
        Session session = null;
        try
        {
            session = mwaevent.getSession();
            java.sql.Connection connection = session.getConnection();
            xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
            RequisitionNumLOV requisitionnumlov = rcptgenpage.getReqNumFld();
            String s = requisitionnumlov.getReqHeaderID();
            String s1 = requisitionnumlov.getReqNum();
            if(UtilFns.isTraceOn)
                UtilFns.trace("ReqhdrId + reqhdrNo " + s + ":" + s1);
            session.putObject("REQUISITION_NUMBER", s1);
            session.putObject("REQUISITION_HEADER_ID", s);
            session.putObject("RCV.REQUISITION_NUM_LOV", requisitionnumlov);
            LPNLOV lpnlov = rcptgenpage.getFromLPNFld();
            String s2 = (new Long(lpnlov.getLPNId())).toString();
            if(s2.equals("0") || s2.equals(""))
                s2 = null;
            String s3 = rcptgenpage.getItemFld().getItemID();
            if(s3.equals(""))
                s3 = null;
            String as[] = {
                "x_shipment_header_id", "x_return_status", "x_msg_count", "x_msg_data", "p_organization_id", "p_requiition_header_id", "p_item_id", "p_rcv_txn_type", "p_lpn_id"
            };
            String as1[] = {
                "O", "O", "O", "O", "I", "I", "I", "I", "I"
            };
            String as2[] = {
                "N", "V", "N", "V", "N", "N", "N", "V", "N"
            };
            String as3[] = {
                (String)session.getObject("ORGID"), (String)session.getObject("REQUISITION_HEADER_ID"), s3, "RECEIPT", s2
            };
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV : RcptGenFListener - parameters for calling INV_RCV_COMMON_APIS.get_req_shipment_header_id :" + (String)session.getObject("ORGID") + ":" + (String)session.getObject("REQUISITION_HEADER_ID") + ":" + s3 + ":" + "RECEIPT" + ":" + s2);
            Hashtable hashtable = UtilFns.ProcessAPI(connection, "INV_RCV_COMMON_APIS.get_req_shipment_header_id", as, as1, as2, as3);
            String s4 = "S";
            String s5 = "";
            if((String)hashtable.get("x_return_status") != null)
                s4 = (String)hashtable.get("x_return_status");
            if((String)hashtable.get("x_msg_data") != null)
                s5 = (String)hashtable.get("x_msg_data");
            if(!s4.equals("S"))
            {
                if(UtilFns.isTraceOn)
                    UtilFns.trace("RCV: xxxRcptGenFListner - inv_rcv_common_apis.get_req_shipment_header_id failure");
                session.setStatusMessage(UtilFns.getStackedMessages(session));
                throw new AbortHandlerException("RCV: xxxRcptGenFListner - inv_rcv_common_apis.get_req_shipment_header_id failure");
            } else
            {
                String s6 = (String)hashtable.get("x_shipment_header_id");
                String s7 = s6;
                return s7;
            }
        }
        catch(SQLException sqlexception)
        {
            UtilFns.error("RCV: xxxRcptGenFListner - throwing exception when calling inv_rcv_common_apis.get_req_shipment_header_id ", sqlexception);
            session.setStatusMessage(UtilFns.getMessage(session, "INV", "INV_MWA_DB_ERROR"));
            throw new AbortHandlerException("RCV: xxxRcptGenFListener - throwing exception when calling inv_rcv_common_apis.get_req_shipment_header_id : " + sqlexception);
        }
    }

    private int getLocatorControl(Session session)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        Hashtable hashtable = (Hashtable)session.getObject("receiving.po_startup_values_block");
        if(hashtable == null)
        {
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener - Should not have reached here as app-initialization should have created the block");
            throw new AbortHandlerException("RCV: xxxRcptGenFListener: Should not have reached here as app-initialization should have created the block");
        }
        int i = Long.valueOf((String)hashtable.get("org_locator_control")).intValue();
        int j = Integer.parseInt(rcptgenpage.getSubFld().getLocatorType());
        ItemLOV itemlov = rcptgenpage.getItemFld();
        int k = Integer.parseInt(itemlov.getLocationCode());
        LocatorKFF locatorkff = rcptgenpage.getLocFld();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: getLocatorControl orgLocControl:" + i + ":subLocControl:" + j + ":itemLocControl:" + k);
        return locatorkff.getLocatorControl(i, j, k);
    }

    private void jobEntered(MWAEvent mwaevent)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.jobEntered.");
        JobLOV joblov = rcptgenpage.getJobFld();
        String s = rcptgenpage.getDocFld().getPOHeaderID();
        String s1 = rcptgenpage.getPOLineNumFld().getPOLineID();
        String s2 = rcptgenpage.getItemFld().getItemID();
        String s3 = rcptgenpage.getPOReleaseNumFld().getPOReleaseID();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.jobEntered: " + s + ": " + s1 + ": " + s2 + ": " + s3);
        String as[] = {
            " ", "ORGID", s, s1, s2, "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.JOB", s3
        };
        joblov.setInputParameters(as);
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.jobEntered - complete.");
    }

    private void locEntered(MWAEvent mwaevent)
        throws AbortHandlerException, InterruptedHandlerException, DefaultOnlyHandlerException
    {
        Session session = mwaevent.getSession();
        String s = "";
        String s1 = "";
        int i = -1;
        RcptGenPage rcptgenpage = (RcptGenPage)session.getCurrentPage();
        SubinventoryLOV subinventorylov = rcptgenpage.getSubFld();
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.locEntered.");
        if(UtilFns.isPJMOrg(session))
            if((String)session.getObject("PROJECT_ID") != null && !((String)session.getObject("PROJECT_ID")).equals("-9999"))
            {
                s = (String)session.getObject("PROJECT_ID");
                s1 = (String)session.getObject("TASK_ID");
            } else
            {
                s = "";
                s1 = "";
            }
        if(subinventorylov != null && !subinventorylov.getValue().equals(""))
            i = getLocatorControl(session);
        LocatorKFF locatorkff = rcptgenpage.getLocFld();
        ItemLOV itemlov = rcptgenpage.getItemFld();
        if(UtilFns.isTraceOn)
            UtilFns.trace((new StringBuilder()).append("RcptGenFListener: Final Locator control -").append(i).toString());
        if(i == 3)
            locatorkff.setValidateFromLOV(false);
        else
        if(i != -1)
            locatorkff.setValidateFromLOV(true);
        String s2 = "FALSE";
        if(session.getObject("wms_purchased") != null && ((String)session.getObject("wms_purchased")).equals("I"))
            s2 = "TRUE";
        String as[] = {
            " ", "ORGID", "oracle.apps.inv.rcv.server.RcptGenPage.INV.SUB", itemlov.getRestrictLocCode(), itemlov.getItemID(), "oracle.apps.inv.rcv.server.RcptGenPage.INV.LOC", "transaction_type", s2, "PROJECT_ID", "TASK_ID"
        };
        locatorkff.setInputParameters(as);
        String as1[] = {
            "C", "N", "S", "AN", "AN", "S", "N", "AS", "S", "S"
        };
        locatorkff.setInputParameterTypes(as1);
        locatorkff.setProjectTask(s, s1);
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.locEntered. - complete");
    }
    
    private void fromlpnEntered(MWAEvent mwaevent)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener - From LPN Entered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        String s = "";
        s = (String)session.getObject("menu.TransactionSourceType");
        String _tmp = (String)session.getObject("menu.TransactionName");
        LPNLOV lpnlov = rcptgenpage.getFromLPNFld();
        String s1 = (String)session.getObject("RCV.ASN_SHIPMENT_HEADER_ID");
        String s2 = (String)session.getObject("REQUISITION_HEADER_ID");
        if(UtilFns.isTraceOn)
            UtilFns.trace("reqHeader Id in lpnentered: " + s2);
        DOCLOV doclov = rcptgenpage.getDocFld();
        String s3 = doclov.getDocType();
        if(s1 == null || s1.equalsIgnoreCase("NULL"))
            s1 = "";
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.fromlpnEntered - shipmentHeaderID = " + s1);
        ItemLOV itemlov = rcptgenpage.getItemFld();
        String s4 = itemlov.getItemID();
        if(s4.equalsIgnoreCase("NULL"))
            s4 = "";
        if(UtilFns.isTraceOn)
            UtilFns.trace("In Patchset J code.Setting From LPN lov inputs");
        if(s3.equalsIgnoreCase("REQ"))
        {
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener.fromlpnEntered - for Requisition");
            String as[] = {
                " ", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.FROM_LPN", s2, "C", s4
            };
            String as4[] = {
                "C", "S", "AS", "AS", "AS"
            };
            lpnlov.setLOVType("REQEXP_LPN");
            lpnlov.setlovStatement("WMS_LPN_LOVS.GET_REQEXP_LPN");
            boolean aflag[] = new boolean[4];
            aflag[0] = true;
            lpnlov.setSubfieldDisplays(aflag);
            lpnlov.setInputParameterTypes(as4);
            lpnlov.setInputParameters(as);
        } else
        {
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: xxxRcptGenFListener.fromlpnEntered - for Shipment ");
            String as1[] = {
                " ", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.FROM_LPN", s1, "C", s4
            };
            String as5[] = {
                "C", "S", "AS", "AS", "AS"
            };
            lpnlov.setlovStatement("WMS_LPN_LOVS.GET_VENDOR_LPN");
            lpnlov.setLOVType("VENDOR_LPN");
            lpnlov.setInputParameterTypes(as5);
            lpnlov.setInputParameters(as1);
        }
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.fromlpnEntered - complete");
    }

    private void locationEntered(MWAEvent mwaevent) throws AbortHandlerException {
        if(UtilFns.isTraceOn)
            UtilFns.trace("xxlocationEntered - Entered Location entered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        mOrigLocationValue = rcptgenpage.getLocationFld().getValue(); 
        UtilFns.trace("xxlocationEntered - START commit of ITEM WEIGHT");
            updItemWeight(mwaevent);
        UtilFns.trace("xxlocationEntered - END commit of ITEM WEIGHT");
    }

    private void setItemWeight(MWAEvent mwaevent) throws AbortHandlerException {
        try {
         UtilFns.trace("xxxCustomFListener: = Start Callable Statement");          
            //use user session's database connection
            //database connection
           
           Session ses = mwaevent.getSession();
           xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)ses.getCurrentPage();
           CallableStatement cstmt = null;
           Connection con = ses.getConnection();
           double itemWeight;
               cstmt = con.prepareCall("{? = call XXWOM_GetItemWeight(?)}");
               cstmt.registerOutParameter(1, Types.VARCHAR);  
               String vInitItem = rcptgenpage.getItemFld().getItemID();
               UtilFns.trace("xxCustomFListener:fieldExited:vInitItem = "+vInitItem);
               cstmt.setString(2, vInitItem);  
               cstmt.execute();
               itemWeight = cstmt.getDouble(1);//cstmt.getInt(1);
               cstmt.close();                 
               // start call of  page to set the item weight value in the text field
               UtilFns.trace("xxCustomFListener:fieldExited:mwaevent = "+mwaevent);
               UtilFns.trace("xxCustomFListener:fieldExited:rcptgenpage.getWeight() = "+rcptgenpage.getWeight());
               UtilFns.trace("xxCustomFListener:fieldExited:itemWeight = "+itemWeight);
               rcptgenpage.setmWeight(mwaevent, rcptgenpage.getWeight(), String.valueOf(itemWeight));
               UtilFns.trace("xxCustomFListener: = End Callable Statement");
                } catch (SQLException err) {
                    UtilFns.trace("xxCustomFListener:CATCH ERR = " + String.valueOf(err) + Logger.LOG_SEVERITY_ERROR);
                } return;   
             
    }

    private void updItemWeight(MWAEvent mwaevent) throws AbortHandlerException {
        try {
         UtilFns.trace("xxxCustomFListener: = Start commitItemWeight Statement");          
            //use user session's database connection
            //database connection         
           Session ses = mwaevent.getSession();
           xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)ses.getCurrentPage();
           CallableStatement cstmt = null;
           Connection con = ses.getConnection();
               //String s = rcptgenpage.getItemFld().getItemID();
               UtilFns.trace("xxxCustomFListener: = 1");
               cstmt = con.prepareCall("{call XXWOM_UpdItemWeight(?, ?)}");
               UtilFns.trace("xxxCustomFListener: = 2");
               String vInitItem = rcptgenpage.getItemFld().getItemID();
               String vItemWeight = rcptgenpage.getItemWeightField().getValue();
                    UtilFns.trace("xxxCustomFListener: = 3");
               UtilFns.trace("xxCustomFListener:fieldExited:vInitItem = "+vInitItem);
               //UtilFns.trace("xxCustomFListener:fieldExited:vInitOrg = "+vInitOrg);
               UtilFns.trace("xxCustomFListener:fieldExited:vItemWeight = "+vItemWeight);
               cstmt.setString(1, vInitItem);  
               cstmt.setString(2, vItemWeight); 
               cstmt.execute();
               cstmt.close();                 
               // start call of  page to set the item weight value in the text field
               //rcptgenpage.setmWeight(mwaevent, rcptgenpage.getWeight(), itemWeight);
             UtilFns.trace("xxCustomFListener: = End Callable Statement");
                } catch (SQLException err) {
                    UtilFns.trace("xxCustomFListener:CATCH ERR = " + String.valueOf(err) + Logger.LOG_SEVERITY_ERROR);
                } return;                
    }
    
    private void poReleaseNumEntered(MWAEvent mwaevent)
        throws AbortHandlerException
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenFListener.poReleaseNumEntered");
        Session session = mwaevent.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        rcptgenpage.getPOReleaseNumFld();
        DOCLOV doclov = rcptgenpage.getDocFld();
        String s = rcptgenpage.getItemFld().getItemID();
        String as[] = {
            " ", "ORGID", doclov.getPOHeaderID(), "RECEIPT", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.PO_RELEASE_NUMBER", s
        };
        rcptgenpage.getPOReleaseNumFld().setInputParameters(as);
    }

    public void initBean(Session session)
        throws AbortHandlerException
    {
        super.initBean(session);
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();
        if(UtilFns.isTraceOn)
            UtilFns.trace(" in the method initBean()");
        if(UtilFns.isTraceOn)
            UtilFns.trace(" Setting up pointers ");
        poBean = rcptgenpage.getPOFld();
        poLineBean = rcptgenpage.getPOLineNumFld();
        rmaBean = rcptgenpage.getRMAFld();
        reqBean = rcptgenpage.getReqNumFld();
        prjBean = rcptgenpage.getProjectFld();
        taskBean = rcptgenpage.getTaskFld();
        lpnBean = rcptgenpage.getLPNFld();
        poHeaderId = poBean.getPOHeaderID();
        poLineId = poLineBean.getPOLineID();
        oeHeaderId = rmaBean.getOrderHeaderID();
        reqHeaderId = reqBean.getReqHeaderID();
    }

    public void fieldExited(MWAEvent e)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        super.fieldExited(e);
        /*
         * Custom code that will trigger your new methods
         * on your fieldExited() events
         */
        Session userSession = e.getSession();
        xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)userSession.getCurrentPage();
        String s = ((FieldBean)e.getSource()).getName();
        UtilFns.trace("xxx Custom fieldExited: " + s);
        /*
         * If the item field is exited it should call the method
         * that will return the value of the item weight from
         * the item master.
         */
        if (s.equals("INV.ITEM")) {        
             UtilFns.trace("xxx show mItemWeightField"); 
             rcptgenpage.mItemWeightField.setHidden(false);
             itemExitedX(e);
        }
        if (s.equals("mItemWeightField")) {
            UtilFns.trace("exited mItemWeightField"); 
        }        
    }
     

    public void serialEntered(MWAEvent e)
        throws AbortHandlerException
    {
        super.serialEntered(e);
    }

    public void countryEntered(MWAEvent e)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        super.countryEntered(e);
    }

    public void countryExited(MWAEvent e)
        throws AbortHandlerException
    {
        super.countryExited(e);
    }

    public void serialExited(MWAEvent e)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        super.serialExited(e);
    }

    protected void cancelButExited(MWAEvent e)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        super.cancelButExited(e);
    }

    public void validateLotQty(MWAEvent e)
        throws AbortHandlerException
    {
        super.validateLotQty(e);
    }
    
/*
 * Custom method that calls "itemExited" method
 * 
 * NOTE - this is modified specificially for the 
 * PO Receipt page. If you try to use it on other mobile
 * pages it may not work because I didn't want to bring over
 * all the other methods, classes, and variables needed just to get
 * it looking like the oracle seeded code.
 */
 private void itemExitedX(MWAEvent mwaevent)
     throws AbortHandlerException, InterruptedHandlerException, DefaultOnlyHandlerException
 {
     if(UtilFns.isTraceOn)
         UtilFns.trace("RCV: xxxRcptGenFListener.itemExited");
     if(UtilFns.isTraceOn)
         UtilFns.trace((new StringBuilder()).append("RCV: xxxRcptGenFListener.itemExited Action =").append(mwaevent.getAction()).toString());
     
     Session session = mwaevent.getSession();
     String s = "";
     s = (String)session.getObject("TXN.ITEM_CONTROLLED");
     if(s == null)
         s = "";
     xxxRcptGenPage rcptgenpage = (xxxRcptGenPage)session.getCurrentPage();         
     //RcptGenPage rcptgenpage = (RcptGenPage)session.getCurrentPage();
     mOrigItemWeightValue = rcptgenpage.getItemWeightField().getValue();
     ItemLOV itemlov = rcptgenpage.getItemFld();
     LPNLOV lpnlov = rcptgenpage.getLPNFld();
     Hashtable hashtable = (Hashtable)session.getObject("receiving.po_startup_values_block");
     String s1 = "U";//(String)rcptgenpage.getPOStartUpValues().get("wms_install_status");
     if(mwaevent.getAction().equals("MWA_NEXTFIELD") || mwaevent.getAction().equals("MWA_SUBMIT"))
     {
         String s2 = (String)session.getObject("next_item");
         if(s2 == null)
             s2 = "N";
         String s4 = itemlov.getCrossRefUOM();
         if(UtilFns.isTraceOn)
             UtilFns.trace((new StringBuilder()).append("RcptGenFListener: CrossRefUOM ").append(s4).toString());
         if(s4 != null && !s4.equals(""))
         {
             if(UtilFns.isTraceOn)
                 UtilFns.trace("CrossRefUOM is NOT NULL . Set to crossRefUOM");
             rcptgenpage.getUOMFld().setValue(s4);
         }
         if(s2.equals("Y"))
             if(itemlov.getItemID() != null && !itemlov.getItemID().equals("") || itemlov.getSegments() != null && !itemlov.getSegments().equals(""))
             {
                 if(UtilFns.isTraceOn)
                     UtilFns.trace("RCV: xxxRcptGenFListner.itemExited -- Item is entered");
             } else
             {
                 if(UtilFns.isTraceOn)
                     UtilFns.trace("RCV: xxxRcptGenFListner.itemExited -- Item is not entered");
                 session.setNextFieldName("RCV.RCPT_DONE");
                 rcptgenpage.getItemDescFld().setHidden(true);
                 rcptgenpage.getQtyFld().setHidden(true);
                 rcptgenpage.getUOMFld().setHidden(true);
                 rcptgenpage.getLocationFld().setHidden(true);
                 rcptgenpage.getDeliverBut().setHidden(true);
                 rcptgenpage.getNextItemBut().setHidden(true);
                 rcptgenpage.getRemainingQtyFld().setHidden(true);
                 rcptgenpage.getLotFld().setHidden(true);
                 rcptgenpage.getExpDateFld().setHidden(true);
                 rcptgenpage.getLotQtyFld().setHidden(true);
                 rcptgenpage.getLotStatusFld().setHidden(true);
                 rcptgenpage.getRemainingSerialFld().setHidden(true);
                 rcptgenpage.getSerialFld().setHidden(true);
                 rcptgenpage.getFromSerialFld().setHidden(true);
                 rcptgenpage.getToSerialFld().setHidden(true);
                 rcptgenpage.getSerialStatusFld().setHidden(true);
                 UtilFns.trace("duomfields is not null......");
                 if(rcptgenpage.duomFields != null)
                 {
                     UtilFns.trace("duomfields is not null");
                     rcptgenpage.duomFields.getSecUomFld().setHidden(true);
                     rcptgenpage.duomFields.getParentLotFld().setHidden(true);
                     rcptgenpage.duomFields.getLotSecQtyDisplayFld().setHidden(true);
                     rcptgenpage.duomFields.getLotSecQtyConfirmFld().setHidden(true);
                     rcptgenpage.duomFields.getSecQtyConfirmFld().setHidden(true);
                 }
                 session.setRefreshScreen(true);
                 return;
             }
         //showAttachment(mwaevent);
         if(UtilFns.isTraceOn)
             UtilFns.trace("RCV: xxxRcptGenFListner.itemExited - After showAttachment ");
         if(s1.equals("I"))
         {
             String s6 = itemlov.getRevCode();
             if(UtilFns.isTraceOn)
                 UtilFns.trace((new StringBuilder()).append("RCV: xxxRcptGenFListner.itemExited 110 - revCode = ").append(s6).toString());
             if(s6.equals("2"))
             {
                 if(s.equals("YES"))
                 {
                     showItemDescription(mwaevent);
                     if(UtilFns.isTraceOn)
                         UtilFns.trace("RCV: xxxRcptGenFListner - When NextItem & the Transaction is Item Controlled");
                 } else
                 {
                     String s9 = (String)session.getObject("receiving.RoutingID");
                     if(s9 == null)
                         s9 = "";
                     if(s9.equals("3"))
                     {
                         if(session.getObject("RCV.LPNID") != null)
                             session.putObject("RCV.LPNID", "");
                     }
                 }
                 rcptgenpage.getRevFld().setHidden(false);
                 if(UtilFns.isTraceOn)
                     UtilFns.trace("RCV: xxxRcptGenFListner.itemExited 120");
                 String s10 = itemlov.getCrossRefRevision();
                 if(UtilFns.isTraceOn)
                     UtilFns.trace((new StringBuilder()).append("RcptGenFListener: CrossRefRevision ").append(s10).toString());
                 if(s10 != null && !s10.equals(""))
                 {
                     if(UtilFns.isTraceOn)
                         UtilFns.trace(" Default to CrossRefRevision  ");
                     rcptgenpage.getRevFld().setValue(s10);
                 }
             } else
             {
                 if(UtilFns.isTraceOn)
                     UtilFns.trace("RCV: xxxRcptGenFListner.itemExited 130");
                 rcptgenpage.getRevFld().setHidden(true);
                 rcptgenpage.getRevFld().setValue("");
             }
         } else
         {
             if(UtilFns.isTraceOn)
                 UtilFns.trace("RCV: xxxRcptGenFListner.itemExited 110.1 -Org Not WMS Enabled ");
             String s7 = itemlov.getRevCode();
             if(s7.equals("2"))
             {
                 rcptgenpage.getRevFld().setHidden(false);
                 if(UtilFns.isTraceOn)
                     UtilFns.trace("RCV: xxxRcptGenFListner.itemExited 110.2 Rev Control");
                 String s12 = itemlov.getCrossRefRevision();
                 if(UtilFns.isTraceOn)
                     UtilFns.trace((new StringBuilder()).append("RcptGenFListener: CrossRefRevision ").append(s12).toString());
                 if(s12 != null && !s12.equals(""))
                 {
                     if(UtilFns.isTraceOn)
                         UtilFns.trace(" Default to CrossRefRevision  ");
                     rcptgenpage.getRevFld().setValue(s12);
                 }
             } else
             {
                 rcptgenpage.getRevFld().setHidden(true);
                 rcptgenpage.getRevFld().setValue("");
                 if(UtilFns.isTraceOn)
                     UtilFns.trace("RCV: xxxRcptGenFListner.itemExited 110.3 No Rev Control");
             }
             if(s.equals("YES"))
             {
                 //showItemDescription(mwaevent);
                 rcptgenpage.resetLotProps();
                 rcptgenpage.resetSerialProps();
                 if(s7.equals("2"))
                     rcptgenpage.getRevFld().setRequired(false);
             } else
             {
                 if(UtilFns.isTraceOn)
                     UtilFns.trace("Unpack LPN");                 
                 UtilFns.trace("mItemWeightExited: mOrigItemWeightValue => "+mOrigItemWeightValue);
                 if (mOrigItemWeightValue == null || mOrigItemWeightValue == ""){
                     UtilFns.trace("mItemWeightExited: START item weight call");
                     setItemWeight(mwaevent);
                     UtilFns.trace("mItemWeightExited: END item weight call");
                 } else {
                     mOrigLocationValue = rcptgenpage.getLocationFld().getValue();
                     UtilFns.trace("mItemWeightExited: mOrigLocationValue = " + mOrigLocationValue);
                 }                     
                 lpnlov.setHidden(true);
                 String s13 = (String)session.getObject("receiving.RoutingID");
                 if(s13 == null)
                     s13 = "";
                 if(!s13.equals("3"))
                 {
                     rcptgenpage.resetLotProps();
                     rcptgenpage.resetSerialProps();
                     if(s7.equals("2"))
                         rcptgenpage.getRevFld().setRequired(false);
                 } else
                 {
                     //setDefaultSubLoc(mwaevent);
                     if(s7.equals("2"))
                         rcptgenpage.getRevFld().setRequired(true);
                 }
             }
         }
         String s8 = (String)session.getObject("receiving.RoutingID");
         if(s8 == null)
             s8 = "";
         if(!s.equals("YES") && UtilFns.isPJMOrg(session) && (s1.equals("I") || s8.equals("3")))
         {
             session.removeObject("PROJECT_ID");
             session.removeObject("PROJECT_NAME");
             session.removeObject("TASK_ID");
             session.removeObject("TASK_NAME");
             DOCLOV doclov = rcptgenpage.getDocFld();
             String s15 = doclov.getDocType();
         }
         String s14 = (String)session.getObject("menu.TransactionSourceType");
         if(s14 == null)
             s14 = "";
         String s16 = "";
         if(s14.equals("7") && itemlov.getSerialCode().equals("6"))
         {
             String s18 = "";
             String s19 = (String)session.getObject("menu.TransactionName");
             if(s19 == null)
                 s19 = "";
             if(s19.equals("REQ") || s19.equals("REQEXP"))
                 s18 = "INTREQ";
             else
                 s18 = "INTSHIP";
             String s17;
             try
             {
                 s17 = rcptgenpage.getSrcSrlCtl(mwaevent, s18);
             }
             catch(AbortHandlerException aborthandlerexception)
             {
                 UtilFns.log("RcptGenFListener:itemExited:Error fetching serial ctrl code in src org");
                 session.putObject("RCV.FROM_ORG_SERIAL_CONTROL", "");
                 throw new AbortHandlerException("Error Fetching serial ctrl code in src org");
             }
             if(UtilFns.isTraceOn)
                 UtilFns.trace((new StringBuilder()).append("RcptGenFListener:itemExited:serial control at source org: ").append(s17).toString());
             session.putObject("RCV.FROM_ORG_SERIAL_CONTROL", s17);
         }
         FieldBean fieldbean = (FieldBean)mwaevent.getSource();
         String s20 = UtilFns.setToNextEditableField(session, fieldbean);
         if(s20 == null || s20.equals(""))
             session.setNextFieldName(s20);
         if(rcptgenpage.getItemFld().isDuomControlled())
         {
             UtilFns.trace("item is duom controlled");
             if(rcptgenpage.duomFields == null)
             {
                 UtilFns.trace("duomfields is null");
                 rcptgenpage.duomFields = new DualUOMFields(rcptgenpage);
                 UtilFns.trace("initializing");
                 rcptgenpage.duomFields.init();
                 UtilFns.trace("after init");
             }
             UtilFns.trace("setting duom properties");
             rcptgenpage.setDUOMProps();
             if(rcptgenpage.getItemFld().getChildLotFlag().equals("Y"))
             {
                 UtilFns.trace("is child lot enabled ");
                 rcptgenpage.setParentLotLOV();
             }
         } else
         if(rcptgenpage.duomFields != null)
         {
             rcptgenpage.duomFields.clearAll();
             rcptgenpage.duomFields.hideAll();
         }
         session.setRefreshScreen(true);
     } else
     {
         if(UtilFns.isTraceOn)
             UtilFns.trace("RCV: xxxRcptGenFListner.itemExited 150 ");
         if(mwaevent.getAction().equals("MWA_PREVIOUSFIELD"))
         {
             rcptgenpage.getItemDescFld().setHidden(true);
             rcptgenpage.getQtyFld().setHidden(true);
             rcptgenpage.getUOMFld().setHidden(true);
             rcptgenpage.getLocationFld().setHidden(true);
             if(rcptgenpage.duomFields != null)
             {
                 UtilFns.trace("duomfields is not null");
                 rcptgenpage.duomFields.getSecUomFld().setHidden(true);
                 rcptgenpage.duomFields.getParentLotFld().setHidden(true);
                 rcptgenpage.duomFields.getLotSecQtyDisplayFld().setHidden(true);
                 rcptgenpage.duomFields.getLotSecQtyConfirmFld().setHidden(true);
                 rcptgenpage.duomFields.getSecQtyConfirmFld().setHidden(true);
             }
             rcptgenpage.getDeliverBut().setHidden(true);
             if(rcptgenpage.getDffFld() != null)
                 rcptgenpage.getDffFld().setHidden(true);
             rcptgenpage.getNextItemBut().setHidden(true);
             rcptgenpage.getRemainingQtyFld().setHidden(true);
             rcptgenpage.getLotFld().setHidden(true);
             rcptgenpage.getExpDateFld().setHidden(true);
             rcptgenpage.getLotQtyFld().setHidden(true);
             rcptgenpage.getLotStatusFld().setHidden(true);
             rcptgenpage.getRemainingSerialFld().setHidden(true);
             rcptgenpage.getSerialFld().setHidden(true);
             rcptgenpage.getFromSerialFld().setHidden(true);
             rcptgenpage.getToSerialFld().setHidden(true);
             rcptgenpage.getSerialStatusFld().setHidden(true);
             rcptgenpage.getLPNFld().setHidden(true);
             rcptgenpage.getRevFld().setHidden(true);
             rcptgenpage.getCustomerFld().setHidden(true);
             rcptgenpage.getJobFld().setHidden(true);
             rcptgenpage.getWipLine().setHidden(true);
             rcptgenpage.getOpSeqNum().setHidden(true);
             rcptgenpage.getDept().setHidden(true);
             rcptgenpage.getRequiredQty().setHidden(true);
             if(!s.equals("YES"))
             {
                 UtilFns.trace("it is doc controlled");
                 rcptgenpage.getItemFld().clear();
                 rcptgenpage.getLPNFld().clear();
                 rcptgenpage.getSubFld().clear();
                 rcptgenpage.getLocFld().clear();
                 rcptgenpage.getJobFld().clear();
             }
         }
     }
     if(!s.equals("YES"))
         UtilFns.trace("displayRoutingMsg(mwaevent);");
         //displayRoutingMsg(mwaevent);
     String s3 = (String)session.getObject("receiving.RoutingID");
     String s5 = (String)session.getObject("receiving.prevRoutingID");
     if(s3 == null)
         s3 = "";
     if(s5 == null)
         s5 = "";
     if(UtilFns.isTraceOn)
         UtilFns.trace((new StringBuilder()).append("theroutingid:").append(s3).append("prev:").append(s5).toString());
     if(!s5.equals("") && !s3.equals(s5))
     {
         rcptgenpage.getSubFld().clear();
         rcptgenpage.getLocFld().clear();
     }
     session.putObject("receiving.prevRoutingID", s3);
     try
     {
         UtilFns.populateLaborParameters(session);
     }
     catch(Exception exception)
     {
         if(UtilFns.isTraceOn)
             UtilFns.trace((new StringBuilder()).append("RCV: xxxRcptGenFListner.itemExited Error While Setting Transaction Times").append(exception.toString()).toString());
     }
     if(UtilFns.isTraceOn)
         UtilFns.trace("RCV: xxxRcptGenFListener.itemExited - complete");
     session.setRefreshScreen(true);
 }
 
    private void showItemDescription(MWAEvent mwaevent)
        throws AbortHandlerException
    {
        Session session = mwaevent.getSession();
        RcptGenPage rcptgenpage = (RcptGenPage)session.getCurrentPage();
        ItemLOV itemlov = rcptgenpage.getItemFld();
        if(itemlov.getIsVendorItem().equals("Y"))
        {
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: RcptGenFListner.itemExited 60 ");
            rcptgenpage.getVendorItemFld().setValue(itemlov.getVendorItemNum());
            rcptgenpage.getVendorItemFld().setHidden(false);
        } else
        {
            if(UtilFns.isTraceOn)
                UtilFns.trace("RCV: RcptGenFListner.itemExited 70 ");
            rcptgenpage.getVendorItemFld().setValue("");
            rcptgenpage.getVendorItemFld().setHidden(true);
        }
        String s = (String)session.getObject("CREATE_CROSS_REF");
        if(s == null || !s.equals("Y"))
            if(itemlov.getIsCrossRefItem().equals("C"))
            {
                if(UtilFns.isTraceOn)
                    UtilFns.trace("RCV: RcptGenFListner.itemExited 70.1 ");
                rcptgenpage.getCrossRefItemFld().setValue(itemlov.getCrossRefItemNum());
                rcptgenpage.getCrossRefItemFld().setHidden(false);
            } else
            {
                if(UtilFns.isTraceOn)
                    UtilFns.trace("RCV: RcptGenFListner.itemExited 70.2 ");
                rcptgenpage.getCrossRefItemFld().setValue("");
                rcptgenpage.getCrossRefItemFld().setHidden(true);
            }
        if(rcptgenpage.getPOLineNumFld().getValue() != null && rcptgenpage.getPOLineNumFld().getValue() != "")
            rcptgenpage.getItemDescFld().setValue(rcptgenpage.getPOLineNumFld().getItemDesc());
        else
            rcptgenpage.getItemDescFld().setValue(itemlov.getDesc());
        rcptgenpage.getItemDescFld().setHidden(false);
    } 
 
}